<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: field/hext_kq.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_00a13ab5e3afe633796d5c180ae90994.html">field</a>
  </div>
</div>
<div class="contents">
<h1>hext_kq.c</h1><a href="hext__kq_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2009 Josephat Kalezhi</span>
<a name="l00005"></a>00005 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00008"></a>00008 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00011"></a>00011 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00012"></a>00012 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00013"></a>00013 <span class="comment">    (at your option) any later version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00016"></a>00016 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00017"></a>00017 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00018"></a>00018 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00019"></a>00019 <span class="comment"></span>
<a name="l00020"></a>00020 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00021"></a>00021 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00022"></a>00022 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00023"></a>00023 <span class="comment">*/</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">/*</span>
<a name="l00026"></a>00026 <span class="comment">Karlqvist type ring head model</span>
<a name="l00027"></a>00027 <span class="comment"></span>
<a name="l00028"></a>00028 <span class="comment">Reference:</span>
<a name="l00029"></a>00029 <span class="comment"></span>
<a name="l00030"></a>00030 <span class="comment">C. Denis Mee, Eric D. Daniel,</span>
<a name="l00031"></a>00031 <span class="comment">&quot;Magnetic Recording Technology&quot;</span>
<a name="l00032"></a>00032 <span class="comment">2nd ed. 1990</span>
<a name="l00033"></a>00033 <span class="comment">Sec. 2.1.2, p. 2.3</span>
<a name="l00034"></a>00034 <span class="comment">http://books.google.co.uk/books?id=extQfrcDveYC&amp;pg=SA2-PA1&amp;dq=recording+and+reproduce+theory+middleton&amp;cd=1#v=onepage&amp;q=recording%20and%20reproduce%20theory%20middleton&amp;f=true</span>
<a name="l00035"></a>00035 <span class="comment"></span>
<a name="l00036"></a>00036 <span class="comment">Hx = (Hg/pi)*(atan((g/2 + x)/y) + atan((g/2 - x)/y) )</span>
<a name="l00037"></a>00037 <span class="comment">Hy = -(Hg/2*pi)*log(((g/2 + x)2 + y2)/((g/2 -x)2 + y2))</span>
<a name="l00038"></a>00038 <span class="comment"></span>
<a name="l00039"></a>00039 <span class="comment">Hx/Hy represent the horizontal/vertical component of the field.</span>
<a name="l00040"></a>00040 <span class="comment">Hg is the head gap field</span>
<a name="l00041"></a>00041 <span class="comment">g is the gapsize</span>
<a name="l00042"></a>00042 <span class="comment">x is the horizontal offset</span>
<a name="l00043"></a>00043 <span class="comment">y is the vertical offset</span>
<a name="l00044"></a>00044 <span class="comment">*/</span>
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: hext_kq.c 3024 2010-03-28 17:17:35Z scholz $\n\n&quot;</span>;
<a name="l00047"></a>00047 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="preprocessor">#include &quot;<a class="code" href="griddata_8h.html">griddata.h</a>&quot;</span>
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 <span class="keyword">static</span> <span class="keywordtype">int</span>       doinit=1;
<a name="l00052"></a>00052 <span class="keyword">static</span> <span class="keywordtype">int</span>       fieldon=0;
<a name="l00053"></a>00053 <span class="keyword">static</span> Vec       VHthis;
<a name="l00054"></a>00054 <span class="keyword">static</span> PetscReal hextamp; <span class="comment">/* Field strength in Tesla */</span>
<a name="l00055"></a>00055 
<a name="l00056"></a><a class="code" href="hext__kq_8c.html#aac24a1f9bfe67ce4a008a31375cb1d01">00056</a> <span class="keywordtype">int</span> <a class="code" href="hext__kq_8c.html#aac24a1f9bfe67ce4a008a31375cb1d01">Hext_kq_Init</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   PetscTruth flg;
<a name="l00061"></a>00061   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-hext_kq&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;fieldon,&amp;flg);CHKERRQ(ierr);
<a name="l00062"></a>00062   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00063"></a>00063     fieldon=0;
<a name="l00064"></a>00064     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00065"></a>00065     <span class="stringliteral">&quot;Option -hext_kq not found, using default value: %i (field off)\n&quot;</span>,
<a name="l00066"></a>00066     fieldon
<a name="l00067"></a>00067     );
<a name="l00068"></a>00068   }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00071"></a>00071     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Hext_kq off\n&quot;</span>);
<a name="l00072"></a>00072     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00073"></a>00073   }
<a name="l00074"></a>00074   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Hext_kq on\n&quot;</span>);
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   PetscReal hgapini;
<a name="l00077"></a>00077   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-hext_kq_gapini&quot;</span>,&amp;hgapini,&amp;flg);CHKERRQ(ierr);
<a name="l00078"></a>00078   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00079"></a>00079     hgapini=50.0;
<a name="l00080"></a>00080     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00081"></a>00081     <span class="stringliteral">&quot;Option -hext_kq_gapini not found. Using default value %g\n&quot;</span>,
<a name="l00082"></a>00082     hgapini
<a name="l00083"></a>00083     );
<a name="l00084"></a>00084   }
<a name="l00085"></a>00085   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;hext_kq_gapini %g\n&quot;</span>,hgapini);
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   PetscReal gapsize;
<a name="l00088"></a>00088   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-hext_kq_gapsize&quot;</span>,&amp;gapsize,&amp;flg);CHKERRQ(ierr);
<a name="l00089"></a>00089   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00090"></a>00090     gapsize=25.0;
<a name="l00091"></a>00091     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00092"></a>00092     <span class="stringliteral">&quot;Option -hext_kq_gapsize not found. Using default value %g\n&quot;</span>,
<a name="l00093"></a>00093     gapsize
<a name="l00094"></a>00094     );
<a name="l00095"></a>00095   }
<a name="l00096"></a>00096   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;kq_gap_size %g\n&quot;</span>,gapsize);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   PetscReal x_offset;
<a name="l00099"></a>00099   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-hext_kq_x_offset&quot;</span>,&amp;x_offset,&amp;flg);CHKERRQ(ierr);
<a name="l00100"></a>00100   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00101"></a>00101     x_offset=0.0;
<a name="l00102"></a>00102     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00103"></a>00103     <span class="stringliteral">&quot;Option -hext_kq_x_offset not found. Using default value %g\n&quot;</span>,
<a name="l00104"></a>00104     x_offset
<a name="l00105"></a>00105     );
<a name="l00106"></a>00106   }
<a name="l00107"></a>00107   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;kq_value of x_offset %g\n&quot;</span>,x_offset);
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   PetscReal z_offset;
<a name="l00110"></a>00110   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-hext_kq_z_offset&quot;</span>,&amp;z_offset,&amp;flg);CHKERRQ(ierr);
<a name="l00111"></a>00111   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00112"></a>00112     z_offset=0.0;
<a name="l00113"></a>00113     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00114"></a>00114     <span class="stringliteral">&quot;Option -hext_kq_z_offset not found. Using default value %g\n&quot;</span>,
<a name="l00115"></a>00115     z_offset
<a name="l00116"></a>00116     );
<a name="l00117"></a>00117   }
<a name="l00118"></a>00118   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;kq_z_offset %g\n&quot;</span>,z_offset);
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;VHthis);CHKERRQ(ierr);
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <span class="comment">/* this sets the external field according to Karlqvist */</span>
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="comment">/* make the vector of the external field accessible */</span>
<a name="l00125"></a>00125   PetscReal *ta_Hext;
<a name="l00126"></a>00126   ierr = VecGetArray(VHthis,&amp;ta_Hext);CHKERRQ(ierr);
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   hgapini *=1000.0; <span class="comment">/* in A/m */</span>
<a name="l00129"></a>00129   hgapini /= gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>; <span class="comment">/* scaled */</span>
<a name="l00130"></a>00130   hextamp=hgapini;
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>; j++) {
<a name="l00133"></a>00133     PetscReal x,y,z;
<a name="l00134"></a>00134     x = gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[j]+0];
<a name="l00135"></a>00135     y = gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[j]+1];
<a name="l00136"></a>00136     z = gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[j]+2];
<a name="l00137"></a>00137 
<a name="l00138"></a>00138     <span class="comment">/* Using a ring head */</span>
<a name="l00139"></a>00139 
<a name="l00140"></a>00140     PetscReal x_coord, z_coord;
<a name="l00141"></a>00141     <span class="comment">/* horizontal separation between head centre and point in question */</span>
<a name="l00142"></a>00142     x_coord = x_offset*1e-9 + x*gdata-&gt;<a class="code" href="structGridData.html#a462c4e47756448bdd7578c61697deb6c">lenscale</a>;
<a name="l00143"></a>00143     <span class="comment">/* vertical separation between head centre and point in question */</span>
<a name="l00144"></a>00144     z_coord = z_offset*1e-9 + z*gdata-&gt;<a class="code" href="structGridData.html#a462c4e47756448bdd7578c61697deb6c">lenscale</a>;
<a name="l00145"></a>00145 
<a name="l00146"></a>00146     PetscReal hx,hy,hz;
<a name="l00147"></a>00147     hx = (hgapini/PETSC_PI)*
<a name="l00148"></a>00148          (atan(((gapsize*1e-9)/2.0 + x_coord)/z_coord) +
<a name="l00149"></a>00149           atan(((gapsize*1e-9)/2.0 - x_coord)/z_coord));
<a name="l00150"></a>00150     hy = 0;
<a name="l00151"></a>00151     hz = -(hgapini/(2*PETSC_PI))*
<a name="l00152"></a>00152          log((((gapsize*1e-9)/2.0 + x_coord)*((gapsize*1e-9)/2.0 + x_coord) + z_coord*z_coord)/
<a name="l00153"></a>00153              (((gapsize*1e-9)/2.0 - x_coord)*((gapsize*1e-9)/2.0 - x_coord) + z_coord*z_coord)
<a name="l00154"></a>00154             );
<a name="l00155"></a>00155 
<a name="l00156"></a>00156     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Coordinates: (%g,%g,%g)\n&quot;</span>,x,y,z);
<a name="l00157"></a>00157     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Field:       (%g,%g,%g)\n&quot;</span>,hx,hy,hz);
<a name="l00158"></a>00158 
<a name="l00159"></a>00159     ta_Hext[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+0]= hx;
<a name="l00160"></a>00160     ta_Hext[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+1]= hy;
<a name="l00161"></a>00161     ta_Hext[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+2]= hz;
<a name="l00162"></a>00162   }
<a name="l00163"></a>00163   ierr = VecRestoreArray(VHthis,&amp;ta_Hext);CHKERRQ(ierr);
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   ierr = VecScale(gdata-&gt;<a class="code" href="structGridData.html#a9fdfeb31eb70dd07c65f5717feddcdbf">VHext</a>,hextamp);CHKERRQ(ierr);
<a name="l00166"></a>00166 
<a name="l00167"></a>00167   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00168"></a>00168 }
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a><a class="code" href="hext__kq_8c.html#a30cb382d2ba1eb8b00264cf43ce43e05">00171</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#a30cb382d2ba1eb8b00264cf43ce43e05">Hext_kq</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,Vec VHextsum,PetscReal *hext)
<a name="l00172"></a>00172 {
<a name="l00173"></a>00173   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00174"></a>00174 
<a name="l00175"></a>00175   <span class="keywordflow">if</span> (doinit) {
<a name="l00176"></a>00176     ierr = <a class="code" href="hext__kq_8c.html#aac24a1f9bfe67ce4a008a31375cb1d01">Hext_kq_Init</a>(gdata);CHKERRQ(ierr);
<a name="l00177"></a>00177     doinit=0;
<a name="l00178"></a>00178   }
<a name="l00179"></a>00179   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00180"></a>00180     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00181"></a>00181   }
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   ierr = VecAXPY(VHextsum,1.0,VHthis);CHKERRQ(ierr);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   *hext=hextamp;
<a name="l00186"></a>00186 
<a name="l00187"></a>00187   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00188"></a>00188 }
<a name="l00189"></a>00189 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

